//---------------------------- CYLON  TEXT ------------------------------
//                by Carl Paulson      Cognitive Portals
//                 http://members.tripod.com/~SleepyCP/
//                          cpaulson@home.com
//-----------------------------------------------------------------------
//
//  Suggested HTML Input:
/*
  <APPLET code="Cylon.class" width=600 height=40>
      <param name=MSG        value="By Your Command.">

      <param name=FONT       value="Helvetica">
      <param name=STYLE      value="0">
      <param name=SIZE       value="10">

      <param name=PauseIn    value="10">

      <param name=BG_Color   value="black">
      <param name=FG_Color   value="red">

      <param name=DeltaH     value="0">   // adjust the Horizontal msg pos
      <param name=DeltaV     value="-20"> // adjust the Verticle msg pos

      <CENTER><FONT SIZE=3>{If you can read this, your browser dosen`t support Java.}</FONT><BR>
      <FONT FACE="Helvetica" SIZE=7>I Liked Battlestar Galactica</FONT></CENTER><BR>
  </APPLET>
*/
//-----------------------------------------------------------------------

import java.applet.Applet;
import java.util.*;
import java.awt.*;

public class Cylon extends Applet implements Runnable {

    private boolean     debug    = true;
    private boolean     Bool1    = false;
    private String      CylonMsg = "";
    private int         pause;
    private Font        Font1;
    private String      Font1Name;
    private int         Font1Style, Font1Size;
    private FontMetrics fm;
    public  Thread      myThread;
    private Color       ColorBG,    ColorFG,    Color1[];
    private int         xLoc[];
    private int         fontHeight, MsgLength,  MsgL2,    x,   y;
    private float       cPct;
    private float       rComp,      gComp,      bComp;
    private float       rDelta,     gDelta,     bDelta;
    private Graphics    gBuffer;
    private Image       iBuffer;
    private int         Height1,    Width1;
    private int         iCount;

    public void init() {

        Font1Name   = getStringParam("FONT","Helvetica");
        Font1Size   = getIntParam("SIZE",10,6,48);
        Font1Style  = getIntParam("STYLE",0,0,3);
        setFont(new Font(Font1Name, Font1Style, Font1Size));

        fm = getFontMetrics(getFont());    // metrics from chosen font
        fontHeight = fm.getHeight();

        CylonMsg   = getStringParam("MSG","It Shall be done master!");
        MsgLength  = CylonMsg.length();

        xLoc       = new int[MsgLength + 1];
        xLoc[0]    = 0;
        for (int i=0; i < MsgLength; i++) {
            String S1 = CylonMsg.substring(0, i+1);
            xLoc[i+1] = fm.stringWidth(S1);
            System.out.println("Color:S1,i = "+S1+"  "+i); //CCP
        }

        Color1     = new Color[2*MsgLength];
        iCount     = 0;
        
        ColorFG  = getColorParam("FG_Color", "RED");
        setForeground(ColorFG);
        ColorBG    = getColorParam("BG_Color", "Black");
        setBackground(ColorBG);

        for (int i=0; i < 2*MsgLength; i++) Color1[i] = ColorBG;
        Color1[MsgLength - 1] = ColorFG;

        if (MsgLength > 0) {
            cPct   = (float) (MsgLength - 1);

            rComp  = ColorFG.getRed();
            gComp  = ColorFG.getGreen();
            bComp  = ColorFG.getBlue();

            rDelta = ColorBG.getRed();
            gDelta = ColorBG.getGreen();
            bDelta = ColorBG.getBlue();

            rDelta = (rDelta - rComp)/cPct;
            gDelta = (gDelta - gComp)/cPct;
            bDelta = (bDelta - bComp)/cPct;
        }

        for (int i=1; i < MsgLength; i++) {
            rComp += rDelta;
            gComp += gDelta;
            bComp += bDelta;
            int j  = MsgLength - 1 - i;
            int k  = MsgLength - 1 + i;
            Color1[j] = new Color((int)rComp, (int)gComp, (int)bComp);
            Color1[k] = new Color((int)rComp, (int)gComp, (int)bComp);
            System.out.println("Color:i,j,k = "+i+"  "+j+"  "+k); //CCP
        }

        int DEL_H  = getIntParam("DeltaH",0,-100,100);
        Width1     = size().width;
        x          = DEL_H + (Width1 - xLoc[MsgLength - 1])/2;

        int DEL_V  = getIntParam("DeltaV",0,-100,100);
        Height1    = size().height;
        y          = (Height1 - fontHeight)/2 - DEL_V;

        pause      = getIntParam("PauseIn",100,10,500);
    }

    // ------------------------------------------------------------------

    public void start() {
        if (!Bool1) {
            if (myThread == null) 
                myThread = new Thread(this);
            myThread.start();
        }
    }

    //-------------------------------------------------------------------

    public void stop() {
        myThread = null;
        myThread.stop();
    }

    //-------------------------------------------------------------------
                            /** @deprecated */
    public boolean mouseDown(Event event, int i, int j) {
        if (Bool1) {
            Bool1 = false;
            start();
        } else {
            Bool1 = true;
            stop();
        }
        return true;
    }

    //-------------------------------------------------------------------
/*
    public boolean handleEvent(Event evt) {
        switch(evt.id) {
            case Event.WINDOW_DESTROY: 
                {
                    System.exit(0);
                    return true;
                }
            case Event.WINDOW_ICONIFY:
                {
                    Bool1 = true;
                    stop();
                    return true;
                }
            case Event.WINDOW_DEICONIFY:
                {
                    Bool1 = false;
                    start();
                    return true;
                }
            default:
                    return false;
            }
    }
*/
    // --------------------- implement Runnable -------------------------

    public void run() {	

        while (myThread != null) {
            try {
                myThread.sleep (pause);
            } catch (InterruptedException e) {
                e.printStackTrace();
                System.out.println(" AAAAA "); //CCP
            }
            repaint();
        }
    }

    // ---------------------  Create a buffer --=------------------------

    public void createBuffers() { 
        iBuffer = createImage(Width1, Height1);
        gBuffer = iBuffer.getGraphics();
    }

    // -------------- Override: Prevent Clearing Screen -----------------

    public void update(Graphics g) { 
        paint(g);
    }

    // ------------------------------------------------------------------

    public synchronized void paint(Graphics g) {

        int j, k;

        if(gBuffer == null) createBuffers();
        gBuffer.setColor(ColorBG);
        gBuffer.fillRect(0, 0, Width1, Height1);

        int    x1 = x;
        int    y1 = y;
        String S1;

        if (iCount >= (2*MsgLength)) iCount = 0;
        j  =   MsgLength - iCount - 1;
        k  =   iCount - MsgLength;

        if (iCount < MsgLength) {

            for (int i=0; i < MsgLength; i++) {
                S1 = CylonMsg.substring(i, i+1);
                x1 = xLoc[i] + x;
//              System.out.println("AAA:i,j,k,iCount = "+i+"  "+j+"  "+k+"  "+iCount); //CCP
                gBuffer.setColor(Color1[j+i]);
                gBuffer.drawString(S1, x1, y1);
            }

        } else {

            for (int i=0; i < MsgLength; i++) {
                S1 = CylonMsg.substring(i, i+1);
                x1 = xLoc[i] + x;
//              System.out.println("BBB:i,j,k,iCount = "+i+"  "+j+"  "+k+"  "+iCount); //CCP
                gBuffer.setColor(Color1[k+i]);
                gBuffer.drawString(S1, x1, y1);
            }

        }
        iCount++;

        g.drawImage(iBuffer, 0, 0, this);
/*
        if (iCount == (2*MsgLength)) {
            Bool1 = true; // CCP
            stop();
        }
*/
    }

    // ------------------------ getString -------------------------------

    public String getStringParam(String x, String def_X) {
        String str;
        str = getParameter(x);
        if (str == null) str = def_X;
        return str;
    }

    // ----------------------- getInteger -------------------------------

    public int getIntParam(String i, int def_I, int min_i, int max_i) {
        int i_in;
        try {
            i_in = Integer.parseInt(getParameter(i));
            if ((i_in < min_i)||(i_in > max_i)) throw new Exception();
        } catch (Exception e) {
            System.out.println(i+" invalid; using default value: "+def_I);
            i_in = def_I;
        }	
        return i_in;
    }

    // ------------------------ getColor --------------------------------

    public Color getColorParam(String c, String def_C) {

        Color Color1 = Color.lightGray;      // default color
        if (def_C != null) {
            if      (def_C.equalsIgnoreCase("black"))     Color1 = Color.black;
            else if (def_C.equalsIgnoreCase("blue"))      Color1 = Color.blue;
            else if (def_C.equalsIgnoreCase("cyan"))      Color1 = Color.cyan;
            else if (def_C.equalsIgnoreCase("darkGray"))  Color1 = Color.darkGray;
            else if (def_C.equalsIgnoreCase("gray"))      Color1 = Color.gray;
            else if (def_C.equalsIgnoreCase("green"))     Color1 = Color.green;
            else if (def_C.equalsIgnoreCase("lightGray")) Color1 = Color.lightGray;
            else if (def_C.equalsIgnoreCase("magenta"))   Color1 = Color.magenta;
            else if (def_C.equalsIgnoreCase("orange"))    Color1 = Color.orange;
            else if (def_C.equalsIgnoreCase("pink"))      Color1 = Color.pink;
            else if (def_C.equalsIgnoreCase("red"))       Color1 = Color.red;
            else if (def_C.equalsIgnoreCase("white"))     Color1 = Color.white;
            else if (def_C.equalsIgnoreCase("yellow"))    Color1 = Color.yellow;
        }

        StringTokenizer st;
        String rgbDelim = ":,.";
        String c_str = getParameter(c);
        if (c_str != null) st = new StringTokenizer(c_str, rgbDelim);
        else return Color1;

        if      (c_str.equalsIgnoreCase("black"))     return Color.black;
        else if (c_str.equalsIgnoreCase("blue"))      return Color.blue;
        else if (c_str.equalsIgnoreCase("cyan"))      return Color.cyan;
        else if (c_str.equalsIgnoreCase("darkGray"))  return Color.darkGray;
        else if (c_str.equalsIgnoreCase("gray"))      return Color.gray;
        else if (c_str.equalsIgnoreCase("green"))     return Color.green;
        else if (c_str.equalsIgnoreCase("lightGray")) return Color.lightGray;
        else if (c_str.equalsIgnoreCase("magenta"))   return Color.magenta;
        else if (c_str.equalsIgnoreCase("orange"))    return Color.orange;
        else if (c_str.equalsIgnoreCase("pink"))      return Color.pink;
        else if (c_str.equalsIgnoreCase("red"))       return Color.red;
        else if (c_str.equalsIgnoreCase("white"))     return Color.white;
        else if (c_str.equalsIgnoreCase("yellow"))    return Color.yellow;

        else if (st.countTokens() == 3) {
            Integer r = new Integer(st.nextToken());
            Integer g = new Integer(st.nextToken());
            Integer b = new Integer(st.nextToken());
            Color1    = new Color(r.intValue(), g.intValue(), b.intValue());
            return Color1;
            }
        return Color1;
    }

    // ------------------------------------------------------------------

}

